/*
								+---------------------------------+
								|                                 |
								|      ***   BSP Loader   ***     |
								|                                 |
								|    Copyright  L. Polok  2001   |
								|                                 |
								|           Load_BSP.cpp          |
								|                                 |
								+---------------------------------+
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "Load_bsp.h"

// nahraje nodu ze souboru BSP_fp
BSP_Node *Read_Node(FILE *BSP_fp, BSP_Tree *tree)
{
	__int16 int16[1];
	BSP_Node *nod;
	int i;

	if((nod = (BSP_Node*) malloc(sizeof(BSP_Node))) == NULL)
		return NULL;
	// alokuje pam pro nodu

	fread(int16, sizeof(int16), 1, BSP_fp);
	nod->flags = int16[0];
	// te vlastnosti nody

	fread(&nod->rootpl.a, sizeof(float), 1, BSP_fp);
	fread(&nod->rootpl.b, sizeof(float), 1, BSP_fp);
	fread(&nod->rootpl.c, sizeof(float), 1, BSP_fp);
	fread(&nod->rootpl.d, sizeof(float), 1, BSP_fp);
	// te normlu root facu

	fread(int16, sizeof(int16), 1, BSP_fp);
	nod->n_onplane_num = int16[0];
	// te poet fac

	if((nod->onplane = (Face*) malloc(int16[0] * sizeof(Face))) == NULL)
		return NULL;
	// alokuje pam pro facelist

	for(i = 0; i < nod->n_onplane_num; i ++) {
		fread(int16, sizeof(int16), 1, BSP_fp);
		nod->onplane[i].vertex[0] = &tree->vertex[int16[0]];
		//
		fread(int16, sizeof(int16), 1, BSP_fp);
		nod->onplane[i].vertex[1] = &tree->vertex[int16[0]];
		//
		fread(int16, sizeof(int16), 1, BSP_fp);
		nod->onplane[i].vertex[2] = &tree->vertex[int16[0]];
		// te veretxy

		fread(int16, sizeof(int16), 1, BSP_fp);
		nod->onplane[i].n_id = int16[0];
		// te id jednotlivch fac

		fread(int16, sizeof(int16), 1, BSP_fp);
		nod->onplane[i].n_material = int16[0];
		// te jmno materilu face

		fread(&nod->onplane[i].normal.a, sizeof(float), 1, BSP_fp);
		fread(&nod->onplane[i].normal.b, sizeof(float), 1, BSP_fp);
		fread(&nod->onplane[i].normal.c, sizeof(float), 1, BSP_fp);
		fread(&nod->onplane[i].normal.d, sizeof(float), 1, BSP_fp);
		// normla
	}
	// te facy

	if(nod->flags & _Have_Front_Node)
		nod->front = Read_Node(BSP_fp, tree);

	if(nod->flags & _Have_Back_Node)
		nod->back = Read_Node(BSP_fp, tree);
	// te dal subnody

	return nod;
}

// nahraje bsp-strom ze souboru f_name
BSP_Tree *Load_Tree(char *f_name)
{
	char tmpname[256];
	__int16 int16[1];
	BSP_Tree *tree;
	FILE *BSP_fp;
	char chr[3];
	int i;

	if((BSP_fp = fopen(f_name, "rb")) == NULL)
		return NULL;
	// oteve soubor (binrn!)

	fread(chr, sizeof(chr), 1, BSP_fp);
	// zape typ souboru - "BSP"

	if(chr[0] != 'B' || chr[1] != 'S' || chr[2] != 'P')
		return NULL;
	// nespravny typ souboru

	fread(int16, sizeof(int16), 1, BSP_fp);
	// nate verzi souboru - 50

	//if(int16[0] != 50)
		//return NULL;
	// nesprvn verze souboru

	if((tree = (BSP_Tree*) malloc(sizeof(BSP_Tree))) == NULL)
		return NULL;
	// alokuje pamet pro strom

	fread(int16, sizeof(int16), 1, BSP_fp);
	tree->n_vertex_num = int16[0];
	// poet vertexu

	fread(int16, sizeof(int16), 1, BSP_fp);
	tree->n_face_num = int16[0];
	// zapise poet facu

	fread(int16, sizeof(int16), 1, BSP_fp);
	tree->n_material_num = int16[0];
	// poet materialu

	if((tree->material = (Material*)malloc(int16[0] * sizeof(Material))) == NULL)
		return NULL;
	// alokuje pamet pro materialy

	for(i = 0; i < tree->n_material_num; i ++) {
		fread(tmpname, 256, 1, BSP_fp);
		if((tree->material[i].name = (char*)malloc(strlen(tmpname) + 1)) == NULL)
			return NULL;
		strcpy(tree->material[i].name, tmpname);
	}
	// te jmna materil

	if((tree->vertex = (Vertex*) malloc(tree->n_vertex_num * sizeof(Vertex))) == NULL)
		return NULL;
	// alokace

	for(i = 0; i < tree->n_vertex_num; i ++) {
		fread(&tree->vertex[i].x, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].y, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].z, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].u, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].v, sizeof(float), 1, BSP_fp);
		// coords

		fread(&tree->vertex[i].normal.x, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].normal.y, sizeof(float), 1, BSP_fp);
		fread(&tree->vertex[i].normal.z, sizeof(float), 1, BSP_fp);
		// normals
	}
	// te vertexy

	tree->root = Read_Node(BSP_fp, tree);
	// te nody

	fclose(BSP_fp);
	// uzave soubor

	return tree;
}