/*
								+---------------------------------+
								|                                 |
								|      ***   BSP Loader   ***     |
								|                                 |
								|    Copyright  L. Polok  2001   |
								|                                 |
								|            Load_BSP.h           |
								|                                 |
								+---------------------------------+
*/

#ifndef __TEXTURE_INCLUDED
#define __TEXTURE_INCLUDED

struct Texture {
	int n_Width, n_Height;
	unsigned __int32 *texture;
	int A_1, A_2, B_1;
};

#endif

#ifndef __BSP_LOADER_INCLUDED
#define __BSP_LOADER_INCLUDED

typedef float Matrix[4][4];

struct Vector {
    float x, y, z;
};

struct Vertex {
    float x, y, z;
	float u, v;
	//
    Vector normal;
};

struct Plane {
    float a, b, c, d;
};

struct Face {
    int n_id;
	int n_material;
	//
    Vertex *vertex[3];
	//
    Plane normal;
};

struct Material { 
    char *name;
	Texture *texture;
};

struct BSP_Node {
	int flags;
	struct BSP_Node *front, *back;
	int n_rootpoly;
	Plane rootpl;
	Face *onplane;
	int n_onplane_num;
	Face *face;
	int face_num;
};

struct BSP_Tree {
	BSP_Node *root;
	//
	int n_material_num;
	int n_face_num;
	int n_vertex_num;
	//
	Material *material;
	Face *face;
	Vertex *vertex;
	//
	Matrix matrix;
};

enum {
	_Have_Front_Node = 0x01,
	_Have_Back_Node  = 0x02
};

BSP_Tree *Load_Tree(char *f_name);

#endif